=== Tests/Dependency/NoDepB/CMakeLists.txt ===
ADD_LIBRARY( NoDepB NoDepBSrc.c )
# This library depends on NoDepA, but the
# dependency is not explicitly specified.
