=== Tests/Dependency/Three/CMakeLists.txt ===
ADD_LIBRARY( Three ThreeSrc.c )
TARGET_LINK_LIBRARIES( Three One Four )
