=== debian/changelog ===
cmake (2.8.2-2~unity2d1) lucid; urgency=low

  * Backport from Maverick; required to support building libqt[bamf|gconf]
    which are needed by unity-2d

 -- Alex Chiang <achiang@canonical.com>  Wed, 09 Feb 2011 12:05:39 -0700

cmake (2.8.2-2) unstable; urgency=low

  [ Kai Wasserbäch ]
  * debian/control:
    - Added libarchive-dev to Build-Depends.
    - Don't {,B-}D on procps on Hurd, already provided by hurd.
    - Added Homepage field (fixes no-homepage-field).
    - Added new binary package cmake-doc and moved all additional
      documentation there (registered with doc-base now).
  * debian/rules: Use system libarchive.
  * debian/patches:
    - add_libarchive_script.patch: Added to allow building with the system's
      libarchive.
    - fix_spelling_errors.patch: Added. Thanks to Lintian for finding them.

  [ Modestas Vainius ]
  * Build with CTEST_USE_XMLRPC to re-enable XMLRPC support in CTest and add
    fix-CTestTestFailedSubmit-xmlrpc.diff patch to fix a (wrongly) failing test
    in that case.
  * Add cmake-dbg package.
  * Add cmake to cmake-doc Suggests.
  * Start package synopsis with lowercase letter where applicable.

 -- Modestas Vainius <modax@debian.org>  Mon, 12 Jul 2010 02:14:05 +0300

cmake (2.8.2-1) unstable; urgency=low

  * New upstream release:
    - Detects Clang compiler (Closes: #560693).

  [ Kai Wasserbäch ]
  * debian/patches/debian/patches/FindPython_fix_#569321_and_#580503.diff:
    Added. (Closes: #569321, #580503)
  * debian/cmake-data.NEWS: Document the changes of the new patch, so nobody
    gets surprised.

  [ Modestas Vainius ]
  * Update patches:
    - kFreeBSD_Hurd_fixes.diff - remove, merged upstream.
  * Bump Standards-Version to 3.9.0:
    - replace Conflicts: cmake (<= 2.6.2-1) with Breaks in cmake-data;
    - add Breaks: cmake (<= 2.6.2-1) to cmake-gui-curses.
  * Remove deprecated references to /usr/share/common-licenses/BSD from
    debian/copyright.
  * Add packaging copyright to debian/copyright.
  * Include copyright information for Utilities/xml/* in the debian/copyright.

 -- Modestas Vainius <modax@debian.org>  Wed, 30 Jun 2010 11:20:53 +0300

cmake (2.8.1-5) unstable; urgency=low

  [ Kai Wasserbäch ]
  * debian/control: added myself to Uploaders with Modestas' permission.

  [ Modestas Vainius ]
  * Add procps to Build-Depends and cmake Depends. cmake sometimes uses ps
    binary.
  * Fix FindJNI patch (again): avoid using tricky bits of cmake IF() command
    syntax. This should fix FindJNI on architectures which do not need special
    CMAKE_SYSTEM_PROCESSOR handling (e.g. ia64).

 -- Modestas Vainius <modax@debian.org>  Sat, 29 May 2010 02:54:42 +0300
